Index: branches/SHM-dev/source/App/TAppDecoder/TAppDecCfg.cpp
===================================================================
--- branches/SHM-dev/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 817)
+++ branches/SHM-dev/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 820)
@@ -78,7 +78,5 @@
   string cfg_ReconFile;
 #endif
-#if AVC_SYNTAX || SYNTAX_OUTPUT
-  string cfg_BLSyntaxFile;
-#endif
+
   string cfg_TargetDecLayerIdSetFile;
 
@@ -96,17 +94,8 @@
   ("BLSourceHeight,-hgt",   m_iBLSourceHeight,       0, "BL source picture height")
 #endif
-#if AVC_SYNTAX
-  ("BLSyntaxFile,-ibs",    cfg_BLSyntaxFile,  string(""), "BL syntax input file name")  
-#endif
 #endif
 #else
   ("ReconFile,o",     cfg_ReconFile,     string(""), "reconstructed YUV output file name\n"
                                                      "YUV writing is skipped if omitted")
-#endif
-#if SYNTAX_OUTPUT
-  ("BLSyntaxFile,-ibs",    cfg_BLSyntaxFile,  string(""), "BL syntax input file name")
-  ("BLSourceWidth,-wdt",    m_iBLSourceWidth,        0, "BL source picture width")
-  ("BLSourceHeight,-hgt",   m_iBLSourceHeight,       0, "BL source picture height")
-  ("BLFrames,-fr",          m_iBLFrames,       0, "BL number of frames")
 #endif
   ("SkipFrames,s", m_iSkipFrame, 0, "number of frames to skip before random access")
@@ -163,7 +152,4 @@
 #else
   m_pchReconFile = cfg_ReconFile.empty() ? NULL : strdup(cfg_ReconFile.c_str());
-#endif
-#if AVC_SYNTAX || SYNTAX_OUTPUT
-  m_pchBLSyntaxFile = cfg_BLSyntaxFile.empty() ? NULL : strdup(cfg_BLSyntaxFile.c_str());
 #endif
 
Index: branches/SHM-dev/source/App/TAppDecoder/TAppDecCfg.h
===================================================================
--- branches/SHM-dev/source/App/TAppDecoder/TAppDecCfg.h	(revision 817)
+++ branches/SHM-dev/source/App/TAppDecoder/TAppDecCfg.h	(revision 820)
@@ -78,17 +78,5 @@
   Int           m_iBLSourceHeight;
 #endif
-#if AVC_SYNTAX
-  Char*         m_pchBLSyntaxFile;                     ///< input BL syntax file name  
 #endif
-#endif
-#endif
-
-#if SYNTAX_OUTPUT
-  Char*         m_pchBLSyntaxFile;                     ///< input BL syntax file name
-#if !REPN_FORMAT_IN_VPS
-  Int           m_iBLSourceWidth;
-  Int           m_iBLSourceHeight;
-#endif
-  Int           m_iBLFrames;
 #endif
 
@@ -116,9 +104,4 @@
   , m_iBLSourceHeight(0)
 #endif
-#if SYNTAX_OUTPUT
-  , m_iBLSourceWidth(0)
-  , m_iBLSourceHeight(0)
-  , m_iBLFrames(0)
-#endif
 #endif
   , m_respectDefDispWindow(0)
Index: branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.cpp	(revision 817)
+++ branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.cpp	(revision 820)
@@ -102,11 +102,4 @@
   }
 #endif
-#if AVC_SYNTAX || SYNTAX_OUTPUT
-  if( m_pchBLSyntaxFile )
-  {
-    free ( m_pchBLSyntaxFile );
-    m_pchBLSyntaxFile = NULL;
-  }
-#endif
 }
 
@@ -163,18 +156,7 @@
   }
   TComList<TComPic*> *cListPic = m_acTDecTop[0].getListPic();
-#if AVC_SYNTAX || !REPN_FORMAT_IN_VPS
-  m_acTDecTop[0].setBLsize( m_iBLSourceWidth, m_iBLSourceHeight );
-#endif
   m_acTDecTop[0].setBLReconFile( &streamYUV );
   pcBLPic.setLayerId( 0 );
   cListPic->pushBack( &pcBLPic );
-#if AVC_SYNTAX
-  fstream streamSyntaxFile;
-  if( m_pchBLSyntaxFile )
-  {
-    streamSyntaxFile.open( m_pchBLSyntaxFile, fstream::in | fstream::binary );
-  }
-  m_acTDecTop[0].setBLSyntaxFile( &streamSyntaxFile );
-#endif
 #endif
 
@@ -363,10 +345,4 @@
     streamYUV.close();
   }
-#if AVC_SYNTAX
-  if( streamSyntaxFile.is_open() )
-  {
-    streamSyntaxFile.close();
-  }
-#endif
   pcBLPic.destroy();
 
@@ -405,25 +381,4 @@
   Bool openedReconFile = false; // reconstruction file not yet opened. (must be performed after SPS is seen)
   Bool loopFiltered = false;
-
-#if SYNTAX_OUTPUT
-  if( !m_pchBLSyntaxFile )
-  {
-    printf( "Wrong base layer syntax file\n" );
-    exit(EXIT_FAILURE);
-  }
-  fstream streamSyntaxFile( m_pchBLSyntaxFile, fstream::out | fstream::binary );
-  if( !streamSyntaxFile.good() )
-  {
-    printf( "Base layer syntax input reading error\n" );
-    exit(EXIT_FAILURE);
-  }
-  m_cTDecTop.setBLSyntaxFile( &streamSyntaxFile );
-
-  for( Int i = m_iBLFrames * m_iBLSourceWidth * m_iBLSourceHeight * SYNTAX_BYTES / 16; i >= 0; i-- )
-  {
-    streamSyntaxFile.put( 0 );
-  }
-  streamSyntaxFile.seekp( 0 );
-#endif
 
   while (!!bitstreamFile)
@@ -542,11 +497,4 @@
     }
   }
-
-#if SYNTAX_OUTPUT
-  if( streamSyntaxFile.is_open() )
-  {
-    streamSyntaxFile.close();
-  }
-#endif
 
   xFlushOutput( pcListPic );
@@ -873,20 +821,11 @@
         if ( m_pchReconFile )
         {
-#if SYNTAX_OUTPUT
-          TComPicYuv* pPicCYuvRec = pcPic->getPicYuvRec();
-#if Q0074_SEI_COLOR_MAPPING
-          if( m_acTDecTop[layerIdx].m_ColorMapping->getColorMappingFlag() )
-          {
-            pPicCYuvRec = m_acTDecTop[layerIdx].m_ColorMapping->getColorMapping( pPicCYuvRec, 0, layerIdx );
-          }
-#endif
           const Window &conf = pcPic->getConformanceWindow();
           const Window &defDisp = m_respectDefDispWindow ? pcPic->getDefDisplayWindow() : Window();
-          m_cTVideoIOYuvReconFile.write( pPicCYuvRec,
-            conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
-            conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
-            conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
-            conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset() );
-#endif
+          m_cTVideoIOYuvReconFile.write( pcPic->getPicYuvRec(),
+                                        conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
+                                        conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
+                                        conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
+                                        conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset() );
         }
 
Index: branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 817)
+++ branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 820)
@@ -510,7 +510,4 @@
   string  cfg_BLInputFile;
 #endif
-#if AVC_SYNTAX
-  string  cfg_BLSyntaxFile;
-#endif
 #if N0383_IL_CONSTRAINED_TILE_SETS_SEI
   string  cfg_tileSets;
@@ -629,7 +626,4 @@
   ("AvcBase,-avc",            m_avcBaseLayerFlag,     0, "avc_base_layer_flag")
   ("InputBLFile,-ibl",        cfg_BLInputFile,     string(""), "Base layer rec YUV input file name")
-#if AVC_SYNTAX
-  ("InputBLSyntaxFile,-ibs",  cfg_BLSyntaxFile,     string(""), "Base layer syntax input file name")
-#endif
 #endif
   ("EnableElRapB,-use-rap-b",  m_elRapSliceBEnabled, 0, "Set ILP over base-layer I picture to B picture (default is P picture)")
@@ -1095,7 +1089,4 @@
 #endif
   m_pBitstreamFile = cfg_BitstreamFile.empty() ? NULL : strdup(cfg_BitstreamFile.c_str());
-#if AVC_SYNTAX
-  m_BLSyntaxFile = cfg_BLSyntaxFile.empty() ? NULL : strdup(cfg_BLSyntaxFile.c_str());
-#endif
 #else //SVC_EXTENSION
   m_pchInputFile = cfg_InputFile.empty() ? NULL : strdup(cfg_InputFile.c_str());
@@ -2933,14 +2924,10 @@
   {
     printf("=== Layer %d settings === \n", layer);
-#if AVC_SYNTAX
-    m_acLayerCfg[layer].xPrintParameter( layer );
-#else
     m_acLayerCfg[layer].xPrintParameter();
-#endif
     printf("\n");
   }
   printf("=== Common configuration settings === \n");
   printf("Bitstream      File          : %s\n", m_pBitstreamFile      );
-#else
+#else //SVC_EXTENSION
   printf("Input          File          : %s\n", m_pchInputFile          );
   printf("Bitstream      File          : %s\n", m_pchBitstreamFile      );
@@ -2948,5 +2935,5 @@
   printf("Real     Format              : %dx%d %dHz\n", m_iSourceWidth - m_confLeft - m_confRight, m_iSourceHeight - m_confTop - m_confBottom, m_iFrameRate );
   printf("Internal Format              : %dx%d %dHz\n", m_iSourceWidth, m_iSourceHeight, m_iFrameRate );
-#endif
+#endif //SVC_EXTENSION
   if (m_isField)
   {
Index: branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.h	(revision 817)
+++ branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.h	(revision 820)
@@ -69,7 +69,4 @@
 #if AVC_BASE
   Int       m_avcBaseLayerFlag;                               ///< avc_baselayer_flag
-#endif
-#if AVC_SYNTAX
-  Char*     m_BLSyntaxFile;                                   ///< input syntax file
 #endif
   Bool      m_maxTidRefPresentFlag; 
@@ -470,7 +467,4 @@
   Int  getWaveFrontSynchro()        { return m_iWaveFrontSynchro; }
   Void getDirFilename(string& filename, string& dir, const string path);
-#if AVC_SYNTAX
-  Char* getBLSyntaxFile()           { return m_BLSyntaxFile;      }
-#endif
   Void cfgStringToArray(Int **arr, string cfgString, Int numEntries, const char* logString);
 #if REPN_FORMAT_IN_VPS
Index: branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.cpp
===================================================================
--- branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.cpp	(revision 817)
+++ branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.cpp	(revision 820)
@@ -157,18 +157,8 @@
 }
 
-#if AVC_SYNTAX
-Void TAppEncLayerCfg::xPrintParameter( UInt layerId )
-#else
 Void TAppEncLayerCfg::xPrintParameter()
-#endif
 {
   printf("Input File                    : %s\n", m_cInputFile.c_str()  );
   printf("Reconstruction File           : %s\n", m_cReconFile.c_str()  );
-#if AVC_SYNTAX
-  if( layerId == 0 )
-  {
-    printf("Base layer syntax file        : %s\n", m_cAppEncCfg->getBLSyntaxFile() );
-  }
-#endif
 #if REPN_FORMAT_IN_VPS
   printf("Real     Format               : %dx%d %dHz\n", m_iSourceWidth - ( m_confLeft + m_confRight ) * TComSPS::getWinUnitX( m_chromaFormatIDC ), m_iSourceHeight - ( m_confTop + m_confBottom ) * TComSPS::getWinUnitY( m_chromaFormatIDC ), m_iFrameRate );
Index: branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.h
===================================================================
--- branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.h	(revision 817)
+++ branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.h	(revision 820)
@@ -122,9 +122,5 @@
   bool  parseCfg  ( const string& cfgFileName );              ///< parse layer configuration file to fill member variables
 
-#if AVC_SYNTAX
-  Void  xPrintParameter( UInt layerId );
-#else
   Void  xPrintParameter();
-#endif
   Bool  xCheckParameter( Bool isField );
 
Index: branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp	(revision 817)
+++ branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp	(revision 820)
@@ -226,5 +226,5 @@
 #if REF_IDX_MFM
 #if AVC_BASE
-    m_acTEncTop[layer].setMFMEnabledFlag(layer == 0 ? false : ( m_avcBaseLayerFlag ? AVC_SYNTAX : true ) && m_acLayerCfg[layer].getNumMotionPredRefLayers());
+    m_acTEncTop[layer].setMFMEnabledFlag(layer == 0 ? false : ( m_avcBaseLayerFlag ? false : true ) && m_acLayerCfg[layer].getNumMotionPredRefLayers());
 #else
     m_acTEncTop[layer].setMFMEnabledFlag(layer == 0 ? false : ( m_acLayerCfg[layer].getNumMotionPredRefLayers() > 0 ) );
@@ -1669,23 +1669,4 @@
   }
 
-#if AVC_SYNTAX
-  fstream streamSyntaxFile;
-  if( m_acTEncTop[0].getVPS()->getAvcBaseLayerFlag() )
-  {
-    if( !m_BLSyntaxFile )
-    {
-      printf( "Wrong base layer syntax input file\n" );
-      exit(EXIT_FAILURE);
-    }
-    streamSyntaxFile.open( m_BLSyntaxFile, fstream::in | fstream::binary );
-    if( !streamSyntaxFile.good() )
-    {
-      printf( "Base layer syntax input reading error\n" );
-      exit(EXIT_FAILURE);
-    }
-    m_acTEncTop[0].setBLSyntaxFile( &streamSyntaxFile );
-  }
-#endif
-
   Bool bFirstFrame = true;
   while ( !bEos )
@@ -1884,11 +1865,4 @@
     m_acTEncTop[layer].deletePicBuffer();
   }
-
-#if AVC_SYNTAX
-  if( streamSyntaxFile.is_open() )
-  {
-    streamSyntaxFile.close();
-  }
-#endif
 
   // delete buffers & classes
@@ -2324,7 +2298,5 @@
       if (m_pchReconFile)
       {
-#if SYNTAX_OUTPUT
         m_cTVideoIOYuvReconFile.write( pcPicYuvRec, m_confLeft, m_confRight, m_confTop, m_confBottom );
-#endif
       }
 